###############################################################################
#
# <p>Discogs 򸡺</p>
# <pre>
#   {{discogs artist,title}}
# </pre>
#
###############################################################################
package plugin::discogs::Discogs;
use LWP::UserAgent;
use XML::Simple;
use Unicode::RecursiveDowngrade;
use Encode qw /from_to decode/;
use Storable qw(nstore retrieve);
use HTML::Entities;
#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}
#==============================================================================
# ѥ饰ե᥽å
#==============================================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $artist = shift;
  my $title = shift;
  my $date = shift;

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  my $key = 'XXXXXXXXXXXXXX';

  my $UserAgent = 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; GTB5; .NET CLR 2.0.50727)';
  
  my $index = $self->{count};
  my $buf = "<div class=\"discogs\"><table><tr><td rowspan=\"20\" width=\"150\">";

  #artist̾Υå
  my $conv = check_letter($artist);

  #artistǸ
  my ($xml1,$xml2);
  my $url_name;
  if($conv) {
    $xml2 = get_xml($self,$wiki,'b',$conv,$key);
    $url_name = $conv;
  }else{
    from_to($artist,"euc-jp","utf8");
    $xml1 = get_xml($self,$wiki,'s',$artist,$key);
    $artist = decide_name($xml1,$artist);
    $xml2 = get_xml($self,$wiki,'a',$artist,$key);
    $url_name = &Util::url_encode($artist);
  }

  #artist
  if($xml2){
    my $count = 0;
    my $savefile = $wiki->config('image_dir')."/$pagename.$index.a.jpg";
    my $images = $xml2->{artist}->[0]{images}->[0]{image};
    my $link = "http://www.discogs.com/artist/".$url_name;
    my $tmp;
    foreach my $image (@{$images}){
      if(($count == 0) || ($image->{type} eq 'primary')){
        $count++;
        save_image($wiki,$image->{uri150},$savefile);
        $tmp = "<a href=\"$link\" target=\"_blank\"><img src=\"".$wiki->config('image_dir')."/".&Util::url_encode($pagename).".$index.a.jpg\"></a>";
      }
    }
    $buf .= $tmp."</td></tr><tr><td>Artist:</td><td><a href=\"$link\" target=\"_blank\">$artist</a></td></tr>";
    my $head = "Url:";
    foreach my $url (@{$xml2->{artist}->[0]{urls}->[0]{url}}){
      unless(ref $url){
        $buf .= "<tr><td>$head</td><td><a href=\"$url\" target=\"_blank\">$url</a></td></tr>";
        $head = "";
      }
    }
  }
  $buf .= "</table>";
  $buf .= "<table><tr><td rowspan=\"200\" valign=\"top\" width=\"150\">";

  #release
  $conv = check_letter($title);
  from_to($title,"euc-jp","utf8");
  my $release = decide_release($xml2,$title,$date,$conv);

  #releaseǸ
  my $xml3 = get_xml($self,$wiki,'r',$release,$key);

  #release
  if($xml3){
    my $count = 0;
    my $savefile = $wiki->config('image_dir')."/$pagename.$index.r.jpg";
    my $images = $xml3->{release}->{$release}->{images}->[0]{image};
    (my $label,my $dummy) = each %{$xml3->{release}->{$release}->{labels}->[0]{label}};
    my $label_url = "http://www.discogs.com/label/".&Util::url_encode($label);
    my $date = $xml3->{release}->{$release}->{released}->[0];
    $date =~ s/-[0-9]+$//;
    $date =~ s/-00//g;
    $date =~ s|-|/|g;
    my $link = "http://www.discogs.com/release/$release/";
    my $tmp;
    foreach my $image (@{$images}){
      if(($count == 0) || ($image->{type} eq 'primary')){
        $count++;
        save_image($wiki,$image->{uri150},$savefile);
        $tmp = "<a href=\"$link\" target=\"_blank\"><img src=\"".$wiki->config('image_dir')."/".&Util::url_encode($pagename).".$index.r.jpg\"></a>";
      }
    }
    $buf .= $tmp."</td></tr><tr><td>Title:</td><td><a href=\"$link\" target=\"_blank\">$title</a></td></tr>";
    $buf .= "<tr><td>Label:</td><td><a href=\"$label_url\" target=\"_blank\">$label</a></td></tr>";
    $buf .= "<tr><td>Released:</td><td>$date</td></tr><tr></tr>";
    my $head = "Track:";
    my $tracks = $xml3->{release}->{$release}->{tracklist}->[0]{track};
    foreach my $track (@{$tracks}){
      my $position = ref $track->{position}->[0] ? "-" : $track->{position}->[0];
      my $duration = ref $track->{duration}->[0] ? "-" : $track->{duration}->[0];
      if(($position eq "-") && ($duration eq "-")){
        $position = $duration = "";
      }else{
        $duration = "[".$duration."]";
      }
      my $title = ref $track->{title}->[0] ? "-" : $track->{title}->[0];
      $title = decode('utf8',$title);
      $title = encode_entities($title);
      $buf .= "<tr><td>$head</td><td>$position\t$duration\t$title</td></tr>";
      $head = "";
    }
  }
  $buf .= "</table></div>";

  $self->{count}++;

  from_to($buf,"utf8","euc-jp");

  return $buf;
}


sub get_xml {
  my $self = shift;
  my $wiki = shift;
  my $mode = shift;
  my $word = shift;
  my $key = shift;

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  if($mode ne 'b') {
    $word = &Util::url_encode($word);
    $word = discogs_url_encode($word);
  }

  my $index = $self->{count};

  my $xml;
  my $cachefile = $wiki->config('log_dir')."/$pagename.$index.$mode.dis";
  my $request_url = "http://www.discogs.com/";
  
  if((-e $cachefile) && !(&newerfile($cachefile, $wiki->config('data_dir')."/$pagename.wiki"))){
    $xml = retrieve $cachefile;
  }else{
    if(($mode eq 'a') || ($mode eq 'b')){
      #http://www.discogs.com/artist/Aphex+Twin?f=xml&api_key=<API_Key>
      $request_url .= "artist/".$word."?f=xml&api_key=".$key;
    }elsif($mode eq 'l'){
      #http://www.discogs.com/label/Svek?f=xml&api_key=<API_Key>
      $request_url .= "label/".$word."?f=xml&api_key=".$key;
    }elsif($mode eq 'r'){
      #http://www.discogs.com/release/1?f=xml&api_key=<API_Key>
      $request_url .= "release/".$word."?f=xml&api_key=".$key;
    }else{
      #http://www.discogs.com/search?type=all&q=afx&f=xml&api_key=<API_Key>
      $request_url .= "search?type=all&q=".$word."&f=xml&api_key=".$key;
    }

    my $ua = LWP::UserAgent->new;
    $ua->agent($UserAgent);
    my $res = $ua->get($request_url, 'Accept-Encoding' => 'gzip',);
    if($res->is_success){
      my $rd = Unicode::RecursiveDowngrade->new;
      $xml = $rd->downgrade(XMLin($res->decoded_content(charset => 'none'),ForceArray => 1));
      nstore $xml,$cachefile;
    }
  }

  return $xml;
}


sub check_letter {
  my $word = shift;

  my ($letter_check1,$letter_check2);

  $letter_check1 = $word;
  from_to($letter_check1,"euc-jp","utf8");
  $letter_check1 = &Util::url_encode($letter_check1);
  $letter_check2 = discogs_url_encode($letter_check1);

  if($letter_check1 ne $letter_check2){
    return $letter_check2;
  }else{
    return 0;
  }
}


sub decide_name {
  my $xml = shift;
  my $original = shift;

  my $artist = "";

  unless($xml->{exactresults}->[0]{result}->[0]{anv}->[0]){
    $artist = $xml->{exactresults}->[0]{result}->[0]{title}->[0];
  }
  
  unless($artist){
    $artist = $xml->{exactresults}->[0]{result}->[0]{uri}->[0];
    $artist =~ s|^http://www.discogs.com/artist/||;
    $artist =~ s|\?anv=.*$||;
    $artist = &Util::url_decode($artist);
  }
  
  unless($artist){
    $artist = $xml->{searchresults}->[0]{result}->[0]{uri}->[0];
    my $type = $xml->{searchresults}->[0]{result}->[0]{type};
    if($type eq 'release'){

      $artist =~ s|^http://www.discogs.com/||;
      $artist =~ s|/release/[0-9]+$||;
      $artist =~ s|-| |g;
    }elsif($type eq 'artist'){
      $artist =~ s|^http://www.discogs.com/artist/||;
      $artist =~ s|-| |g;
    }
    $artist = &Util::url_decode($artist);
  }
  
  unless($artist){
    $artist = $original;
  }

  return $artist;
}


sub decide_release {
  my $xml = shift;
  my $title = shift;
  my $date = shift;
  my $conv = shift;

  my ($ret,$same,$similar);

  unless($conv){
    $title = decode('utf8',$title);
    $title = encode_entities($title);
  }

  my $releases = $xml->{artist}->[0]{releases}->[0]{release};
  while ((my $release, my $value) = each %{$releases}){
    my $enc_title = $value->{title}->[0];
    $enc_title = decode('utf8',$enc_title);
    $enc_title = encode_entities($enc_title);

    if($enc_title eq $title){
      if($value->{year}->[0] eq $date){
        $same = $release;
        last;
      }else{
        $same = $release;
      }
    }elsif($enc_title =~ $title){
      $similar = $release;
    }
  }

  if($same){
    $ret = $same;
  }elsif($similar){
    $ret = $similar;
  }

  return $ret;
}


sub save_image {
  my $wiki = shift;
  my $uri = shift;
  my $file = shift;

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  if((-e $file) && !(&newerfile($file, $wiki->config('data_dir')."/$pagename.wiki"))){
  }else{
    my $UserAgent = 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; GTB5; .NET CLR 2.0.50727)';
    my $ua = LWP::UserAgent->new;
    $ua->agent($UserAgent);
    my $res = $ua->get($uri);
    if($res->is_success){
      my $out = IO::File->new($file, 'w');
      $out->binmode();
      $out->write($res->content, $res->content_length);
      $out->close();
    }
  }
}


#==============================================================================
# ե꿷ե뤬ǥ쥯ȥˤ뤫ǧ
#     1:ե뤬Ĥä
#     0:                Ĥʤä
#    -1:顼
#==============================================================================
sub newerfile {
    my $criterion = shift;	# ˤʤե
    my $file = shift;	# Ӥե

  if ((stat($criterion))[9] < (stat($file))[9]){
    return 1;
  }else{
    return 0;
  }
}

sub discogs_url_encode {
  my $word = shift;
  
  $word =~ s/%26nbsp%3(b|B)/%c2%a0/g;
  $word =~ s/%26iexcl%3(b|B)/%c2%a1/g;
  $word =~ s/%26cent%3(b|B)/%c2%a2/g;
  $word =~ s/%26pound%3(b|B)/%c2%a3/g;
  $word =~ s/%26curren%3(b|B)/%c2%a4/g;
  $word =~ s/%26yen%3(b|B)/%c2%a5/g;
  $word =~ s/%26brvbar%3(b|B)/%c2%a6/g;
  $word =~ s/%26sect%3(b|B)/%c2%a7/g;
  $word =~ s/%26uml%3(b|B)/%c2%a8/g;
  $word =~ s/%26copy%3(b|B)/%c2%a9/g;
  $word =~ s/%26ordf%3(b|B)/%c2%aa/g;
  $word =~ s/%26laquo%3(b|B)/%c2%ab/g;
  $word =~ s/%26not%3(b|B)/%c2%ac/g;
  $word =~ s/%26shy%3(b|B)/%c2%ad/g;
  $word =~ s/%26reg%3(b|B)/%c2%ae/g;
  $word =~ s/%26macr%3(b|B)/%c2%af/g;
  $word =~ s/%26deg%3(b|B)/%c2%b0/g;
  $word =~ s/%26plusmn%3(b|B)/%c2%b1/g;
  $word =~ s/%26sup2%3(b|B)/%c2%b2/g;
  $word =~ s/%26sup3%3(b|B)/%c2%b3/g;
  $word =~ s/%26acute%3(b|B)/%c2%b4/g;
  $word =~ s/%26micro%3(b|B)/%c2%b5/g;
  $word =~ s/%26para%3(b|B)/%c2%b6/g;
  $word =~ s/%26middot%3(b|B)/%c2%b7/g;
  $word =~ s/%26cedil%3(b|B)/%c2%b8/g;
  $word =~ s/%26sup1%3(b|B)/%c2%b9/g;
  $word =~ s/%26ordm%3(b|B)/%c2%ba/g;
  $word =~ s/%26raquo%3(b|B)/%c2%bb/g;
  $word =~ s/%26frac14%3(b|B)/%c2%bc/g;
  $word =~ s/%26frac12%3(b|B)/%c2%bd/g;
  $word =~ s/%26frac34%3(b|B)/%c2%be/g;
  $word =~ s/%26iquest%3(b|B)/%c2%bf/g;
  $word =~ s/%26Agrave%3(b|B)/%c3%80/g;
  $word =~ s/%26Aacute%3(b|B)/%c3%81/g;
  $word =~ s/%26Acirc%3(b|B)/%c3%82/g;
  $word =~ s/%26Atilde%3(b|B)/%c3%83/g;
  $word =~ s/%26Auml%3(b|B)/%c3%84/g;
  $word =~ s/%26Aring%3(b|B)/%c3%85/g;
  $word =~ s/%26AElig%3(b|B)/%c3%86/g;
  $word =~ s/%26Ccedil%3(b|B)/%c3%87/g;
  $word =~ s/%26Egrave%3(b|B)/%c3%88/g;
  $word =~ s/%26Eacute%3(b|B)/%c3%89/g;
  $word =~ s/%26Ecirc%3(b|B)/%c3%8a/g;
  $word =~ s/%26Euml%3(b|B)/%c3%8b/g;
  $word =~ s/%26Igrave%3(b|B)/%c3%8c/g;
  $word =~ s/%26Iacute%3(b|B)/%c3%8d/g;
  $word =~ s/%26Icirc%3(b|B)/%c3%8e/g;
  $word =~ s/%26Iuml%3(b|B)/%c3%8f/g;
  $word =~ s/%26ETH%3(b|B)/%c3%90/g;
  $word =~ s/%26Ntilde%3(b|B)/%c3%91/g;
  $word =~ s/%26Ograve%3(b|B)/%c3%92/g;
  $word =~ s/%26Oacute%3(b|B)/%c3%93/g;
  $word =~ s/%26Ocirc%3(b|B)/%c3%94/g;
  $word =~ s/%26Otilde%3(b|B)/%c3%95/g;
  $word =~ s/%26Ouml%3(b|B)/%c3%96/g;
  $word =~ s/%26times%3(b|B)/%c3%97/g;
  $word =~ s/%26Oslash%3(b|B)/%c3%98/g;
  $word =~ s/%26Ugrave%3(b|B)/%c3%99/g;
  $word =~ s/%26Uacute%3(b|B)/%c3%9a/g;
  $word =~ s/%26Ucirc%3(b|B)/%c3%9b/g;
  $word =~ s/%26Uuml%3(b|B)/%c3%9c/g;
  $word =~ s/%26Yacute%3(b|B)/%c3%9d/g;
  $word =~ s/%26THORN%3(b|B)/%c3%9e/g;
  $word =~ s/%26szlig%3(b|B)/%c3%9f/g;
  $word =~ s/%26agrave%3(b|B)/%c3%a0/g;
  $word =~ s/%26aacute%3(b|B)/%c3%a1/g;
  $word =~ s/%26acirc%3(b|B)/%c3%a2/g;
  $word =~ s/%26atilde%3(b|B)/%c3%a3/g;
  $word =~ s/%26auml%3(b|B)/%c3%a4/g;
  $word =~ s/%26aring%3(b|B)/%c3%a5/g;
  $word =~ s/%26aelig%3(b|B)/%c3%a6/g;
  $word =~ s/%26ccedil%3(b|B)/%c3%a7/g;
  $word =~ s/%26egrave%3(b|B)/%c3%a8/g;
  $word =~ s/%26eacute%3(b|B)/%c3%a9/g;
  $word =~ s/%26ecirc%3(b|B)/%c3%aa/g;
  $word =~ s/%26euml%3(b|B)/%c3%ab/g;
  $word =~ s/%26igrave%3(b|B)/%c3%ac/g;
  $word =~ s/%26iacute%3(b|B)/%c3%ad/g;
  $word =~ s/%26icirc%3(b|B)/%c3%ae/g;
  $word =~ s/%26iuml%3(b|B)/%c3%af/g;
  $word =~ s/%26eth%3(b|B)/%c3%b0/g;
  $word =~ s/%26ntilde%3(b|B)/%c3%b1/g;
  $word =~ s/%26ograve%3(b|B)/%c3%b2/g;
  $word =~ s/%26oacute%3(b|B)/%c3%b3/g;
  $word =~ s/%26ocirc%3(b|B)/%c3%b4/g;
  $word =~ s/%26otilde%3(b|B)/%c3%b5/g;
  $word =~ s/%26ouml%3(b|B)/%c3%b6/g;
  $word =~ s/%26divide%3(b|B)/%c3%b7/g;
  $word =~ s/%26oslash%3(b|B)/%c3%b8/g;
  $word =~ s/%26ugrave%3(b|B)/%c3%b9/g;
  $word =~ s/%26uacute%3(b|B)/%c3%ba/g;
  $word =~ s/%26ucirc%3(b|B)/%c3%bb/g;
  $word =~ s/%26uuml%3(b|B)/%c3%bc/g;
  $word =~ s/%26yacute%3(b|B)/%c3%bd/g;
  $word =~ s/%26thorn%3(b|B)/%c3%be/g;
  $word =~ s/%26yuml%3(b|B)/%c3%bf/g;
  $word =~ s/%26OElig%3(b|B)/%c5%92/g;
  $word =~ s/%26oelig%3(b|B)/%c5%93/g;
  $word =~ s/%26Scaron%3(b|B)/%c5%a0/g;
  $word =~ s/%26scaron%3(b|B)/%c5%a1/g;
  $word =~ s/%26Yuml%3(b|B)/%c5%b8/g;
  $word =~ s/%26fnof%3(b|B)/%c6%92/g;
  $word =~ s/%26circ%3(b|B)/%cb%86/g;
  $word =~ s/%26tilde%3(b|B)/%cb%9c/g;
  $word =~ s/%26Alpha%3(b|B)/%ce%91/g;
  $word =~ s/%26Beta%3(b|B)/%ce%92/g;
  $word =~ s/%26Gamma%3(b|B)/%ce%93/g;
  $word =~ s/%26Delta%3(b|B)/%ce%94/g;
  $word =~ s/%26Epsilon%3(b|B)/%ce%95/g;
  $word =~ s/%26Zeta%3(b|B)/%ce%96/g;
  $word =~ s/%26Eta%3(b|B)/%ce%97/g;
  $word =~ s/%26Theta%3(b|B)/%ce%98/g;
  $word =~ s/%26Iota%3(b|B)/%ce%99/g;
  $word =~ s/%26Kappa%3(b|B)/%ce%9a/g;
  $word =~ s/%26Lambda%3(b|B)/%ce%9b/g;
  $word =~ s/%26Mu%3(b|B)/%ce%9c/g;
  $word =~ s/%26Nu%3(b|B)/%ce%9d/g;
  $word =~ s/%26Xi%3(b|B)/%ce%9e/g;
  $word =~ s/%26Omicron%3(b|B)/%ce%9f/g;
  $word =~ s/%26Pi%3(b|B)/%ce%a0/g;
  $word =~ s/%26Rho%3(b|B)/%ce%a1/g;
  $word =~ s/%26Sigma%3(b|B)/%ce%a3/g;
  $word =~ s/%26Tau%3(b|B)/%ce%a4/g;
  $word =~ s/%26Upsilon%3(b|B)/%ce%a5/g;
  $word =~ s/%26Phi%3(b|B)/%ce%a6/g;
  $word =~ s/%26Chi%3(b|B)/%ce%a7/g;
  $word =~ s/%26Psi%3(b|B)/%ce%a8/g;
  $word =~ s/%26Omega%3(b|B)/%ce%a9/g;
  $word =~ s/%26alpha%3(b|B)/%ce%b1/g;
  $word =~ s/%26beta%3(b|B)/%ce%b2/g;
  $word =~ s/%26gamma%3(b|B)/%ce%b3/g;
  $word =~ s/%26delta%3(b|B)/%ce%b4/g;
  $word =~ s/%26epsilon%3(b|B)/%ce%b5/g;
  $word =~ s/%26zeta%3(b|B)/%ce%b6/g;
  $word =~ s/%26eta%3(b|B)/%ce%b7/g;
  $word =~ s/%26theta%3(b|B)/%ce%b8/g;
  $word =~ s/%26iota%3(b|B)/%ce%b9/g;
  $word =~ s/%26kappa%3(b|B)/%ce%ba/g;
  $word =~ s/%26lambda%3(b|B)/%ce%bb/g;
  $word =~ s/%26mu%3(b|B)/%ce%bc/g;
  $word =~ s/%26nu%3(b|B)/%ce%bd/g;
  $word =~ s/%26xi%3(b|B)/%ce%be/g;
  $word =~ s/%26omicron%3(b|B)/%ce%bf/g;
  $word =~ s/%26pi%3(b|B)/%cf%80/g;
  $word =~ s/%26rho%3(b|B)/%cf%81/g;
  $word =~ s/%26%3(b|B)/%cf%82/g;
  $word =~ s/%26sigma%3(b|B)/%cf%83/g;
  $word =~ s/%26tau%3(b|B)/%cf%84/g;
  $word =~ s/%26upsilon%3(b|B)/%cf%85/g;
  $word =~ s/%26phi%3(b|B)/%cf%86/g;
  $word =~ s/%26chi%3(b|B)/%cf%87/g;
  $word =~ s/%26psi%3(b|B)/%cf%88/g;
  $word =~ s/%26omega%3(b|B)/%cf%89/g;
  $word =~ s/%26thetasym%3(b|B)/%cf%91/g;
  $word =~ s/%26upsih%3(b|B)/%cf%92/g;
  $word =~ s/%26piv%3(b|B)/%cf%96/g;
  $word =~ s/%26ensp%3(b|B)/%e2%80%82/g;
  $word =~ s/%26emsp%3(b|B)/%e2%80%83/g;
  $word =~ s/%26thinsp%3(b|B)/%e2%80%89/g;
  $word =~ s/%26zwnj%3(b|B)/%e2%80%8c/g;
  $word =~ s/%26zwj%3(b|B)/%e2%80%8d/g;
  $word =~ s/%26lrm%3(b|B)/%e2%80%8e/g;
  $word =~ s/%26rlm%3(b|B)/%e2%80%8f/g;
  $word =~ s/%26ndash%3(b|B)/%e2%80%93/g;
  $word =~ s/%26mdash%3(b|B)/%e2%80%94/g;
  $word =~ s/%26lsquo%3(b|B)/%e2%80%98/g;
  $word =~ s/%26rsquo%3(b|B)/%e2%80%99/g;
  $word =~ s/%26sbquo%3(b|B)/%e2%80%9a/g;
  $word =~ s/%26ldquo%3(b|B)/%e2%80%9c/g;
  $word =~ s/%26rdquo%3(b|B)/%e2%80%9d/g;
  $word =~ s/%26bdquo%3(b|B)/%e2%80%9e/g;
  $word =~ s/%26dagger%3(b|B)/%e2%80%a0/g;
  $word =~ s/%26Dagger%3(b|B)/%e2%80%a1/g;
  $word =~ s/%26bull%3(b|B)/%e2%80%a2/g;
  $word =~ s/%26hellip%3(b|B)/%e2%80%a6/g;
  $word =~ s/%26permil%3(b|B)/%e2%80%b0/g;
  $word =~ s/%26prime%3(b|B)/%e2%80%b2/g;
  $word =~ s/%26Prime%3(b|B)/%e2%80%b3/g;
  $word =~ s/%26lsaquo%3(b|B)/%e2%80%b9/g;
  $word =~ s/%26rsaquo%3(b|B)/%e2%80%ba/g;
  $word =~ s/%26oline%3(b|B)/%e2%80%be/g;
  $word =~ s/%26frasl%3(b|B)/%e2%81%84/g;
  $word =~ s/%26euro%3(b|B)/%e2%82%ac/g;
  $word =~ s/%26image%3(b|B)/%e2%84%91/g;
  $word =~ s/%26weierp%3(b|B)/%e2%84%98/g;
  $word =~ s/%26real%3(b|B)/%e2%84%9c/g;
  $word =~ s/%26trade%3(b|B)/%e2%84%a2/g;
  $word =~ s/%26alefsym%3(b|B)/%e2%84%b5/g;
  $word =~ s/%26larr%3(b|B)/%e2%86%90/g;
  $word =~ s/%26uarr%3(b|B)/%e2%86%91/g;
  $word =~ s/%26rarr%3(b|B)/%e2%86%92/g;
  $word =~ s/%26darr%3(b|B)/%e2%86%93/g;
  $word =~ s/%26harr%3(b|B)/%e2%86%94/g;
  $word =~ s/%26crarr%3(b|B)/%e2%86%b5/g;
  $word =~ s/%26lArr%3(b|B)/%e2%87%90/g;
  $word =~ s/%26uArr%3(b|B)/%e2%87%91/g;
  $word =~ s/%26rArr%3(b|B)/%e2%87%92/g;
  $word =~ s/%26dArr%3(b|B)/%e2%87%93/g;
  $word =~ s/%26hArr%3(b|B)/%e2%87%94/g;
  $word =~ s/%26forall%3(b|B)/%e2%88%80/g;
  $word =~ s/%26part%3(b|B)/%e2%88%82/g;
  $word =~ s/%26exist%3(b|B)/%e2%88%83/g;
  $word =~ s/%26empty%3(b|B)/%e2%88%85/g;
  $word =~ s/%26nabla%3(b|B)/%e2%88%87/g;
  $word =~ s/%26isin%3(b|B)/%e2%88%88/g;
  $word =~ s/%26notin%3(b|B)/%e2%88%89/g;
  $word =~ s/%26ni%3(b|B)/%e2%88%8b/g;
  $word =~ s/%26prod%3(b|B)/%e2%88%8f/g;
  $word =~ s/%26sum%3(b|B)/%e2%88%91/g;
  $word =~ s/%26minus%3(b|B)/%e2%88%92/g;
  $word =~ s/%26lowast%3(b|B)/%e2%88%97/g;
  $word =~ s/%26radic%3(b|B)/%e2%88%9a/g;
  $word =~ s/%26prop%3(b|B)/%e2%88%9d/g;
  $word =~ s/%26infin%3(b|B)/%e2%88%9e/g;
  $word =~ s/%26ang%3(b|B)/%e2%88%a0/g;
  $word =~ s/%26and%3(b|B)/%e2%88%a7/g;
  $word =~ s/%26or%3(b|B)/%e2%88%a8/g;
  $word =~ s/%26cap%3(b|B)/%e2%88%a9/g;
  $word =~ s/%26cup%3(b|B)/%e2%88%aa/g;
  $word =~ s/%26int%3(b|B)/%e2%88%ab/g;
  $word =~ s/%26there4%3(b|B)/%e2%88%b4/g;
  $word =~ s/%26sim%3(b|B)/%e2%88%bc/g;
  $word =~ s/%26cong%3(b|B)/%e2%89%85/g;
  $word =~ s/%26asymp%3(b|B)/%e2%89%88/g;
  $word =~ s/%26ne%3(b|B)/%e2%89%a0/g;
  $word =~ s/%26equiv%3(b|B)/%e2%89%a1/g;
  $word =~ s/%26le%3(b|B)/%e2%89%a4/g;
  $word =~ s/%26ge%3(b|B)/%e2%89%a5/g;
  $word =~ s/%26sub%3(b|B)/%e2%8a%82/g;
  $word =~ s/%26sup%3(b|B)/%e2%8a%83/g;
  $word =~ s/%26nsub%3(b|B)/%e2%8a%84/g;
  $word =~ s/%26sube%3(b|B)/%e2%8a%86/g;
  $word =~ s/%26supe%3(b|B)/%e2%8a%87/g;
  $word =~ s/%26oplus%3(b|B)/%e2%8a%95/g;
  $word =~ s/%26otimes%3(b|B)/%e2%8a%97/g;
  $word =~ s/%26perp%3(b|B)/%e2%8a%a5/g;
  $word =~ s/%26sdot%3(b|B)/%e2%8b%85/g;
  $word =~ s/%26lceil%3(b|B)/%e2%8c%88/g;
  $word =~ s/%26rceil%3(b|B)/%e2%8c%89/g;
  $word =~ s/%26lfloor%3(b|B)/%e2%8c%8a/g;
  $word =~ s/%26rfloor%3(b|B)/%e2%8c%8b/g;
  $word =~ s/%26lang%3(b|B)/%e2%8c%a9/g;
  $word =~ s/%26rang%3(b|B)/%e2%8c%aa/g;
  $word =~ s/%26loz%3(b|B)/%e2%97%8a/g;
  $word =~ s/%26spades%3(b|B)/%e2%99%a0/g;
  $word =~ s/%26clubs%3(b|B)/%e2%99%a3/g;
  $word =~ s/%26hearts%3(b|B)/%e2%99%a5/g;
  $word =~ s/%26diams%3(b|B)/%e2%99%a6/g;

  return $word;
}


1;
